## frama-c 20171101+sulfur+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common
include share/Makefile.dynamic_config.internal

#Check share/Makefile.config available
ifndef FRAMAC_ROOT_SRCDIR
$(error "You should run ./configure first (or autoconf if there is no configure)")
endif

###################
# Frama-C Version #
###################

VERSION:=$(shell $(SED) -e 's/\(\.*\)/\1/' VERSION)
VERSION_PREFIX = $(shell $(SED) -e 's/\([a-zA-Z]\+-[0-9]\+\).*/\1/' VERSION)

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin non-GUI files are stored
PLUGIN_TOP_LIB_DIR= $(PLUGIN_LIB_DIR)/top

# the directory where compiled plugin GUI files are stored
PLUGIN_GUI_LIB_DIR= $(PLUGIN_LIB_DIR)/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_GENERATED_LIST:=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_META_LIST :=
PLUGIN_DYN_CMI_LIST :=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR) $(FRAMAC_SRC_DIRS)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories to include when compiling
INCLUDES=$(addprefix -I ,$(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR)
ifneq ($(ENABLE_GUI),no)
GUI_INCLUDES = $(addprefix -package ,$(LIBRARY_NAMES_GUI))
else
GUI_INCLUDES =
endif

# Files for which dependencies must be computed computed.
# Other files are added later in this Makefile.
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli

BFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) \
		$(FRAMAC_USER_FLAGS)
OFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) -compact \
		$(FRAMAC_USER_FLAGS)

BLINKFLAGS += -linkpkg $(BFLAGS) -linkall -custom
OLINKFLAGS += -linkpkg $(OFLAGS) -linkall

DOC_FLAGS= -colorize-code -stars -m A -hide-warnings $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)

# Files that depend on external libraries -namely Zarith- whose interface
# has not been explicitely declared -opaque, hence would trigger warning 58.
# This can't be solve by Frama-C itself, we can only wait for an update of
# said library.

NON_OPAQUE_DEPS:=

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
PACKAGES = $(addprefix -package ,$(LIBRARY_NAMES))
BYTE_LIBS = $(GEN_BYTE_LIBS)
OPT_LIBS = $(EXTRA_OPT_LIBS)

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/,\
		frama-c.ico frama-c.png unmark.png \
		switch-on.png switch-off.png )

FEEDBACK_ICONS_NAMES:= \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png

FEEDBACK_ICONS_DEFAULT:= \
	$(addprefix share/theme/default/,$(FEEDBACK_ICONS_NAMES))
FEEDBACK_ICONS_COLORBLIND:= \
	$(addprefix share/theme/colorblind/,$(FEEDBACK_ICONS_NAMES))

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= sys netinet linux net arpa
LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/,$(LIBC_SUBDIRS))
LIBC_FILES:= \
	$(wildcard share/*.h share/*.c) \
	$(wildcard $(addsuffix /*.h,$(LIBC_DIR))) \
	$(wildcard $(addsuffix /*.c,$(LIBC_DIR)))

# Checks that all .h can be included multiple times.
ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h,$(LIBC_DIR)))

check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
	@echo "checking libc..."; \
	 EXIT_VALUE=0; \
	 for file in $(filter-out share/builtin.h,$(ALL_LIBC_HEADERS)); do \
	   echo "#include \"$$file\"" > check-libc.c; \
	   echo "#include \"$$file\"" >> check-libc.c; \
	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
	   -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
	       > $$(basename $$file .h).log 2>&1; \
	   if test $$? -ne 0; then \
	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
	     else \
	       echo "$$file cannot be included twice. \
Output is in $$(basename $$file .h).log"; \
	       EXIT_VALUE=1; \
	     fi; \
	   else \
	     rm $$(basename $$file .h).log; \
	   fi; \
	 done; \
	 rm check-libc.c; \
	 exit $$EXIT_VALUE

clean-check-libc:
	$(RM) *.log

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=\
      $(wildcard bin/migration_scripts/*2*.sh) bin/local_export.sh                        \
      bin/frama-c bin/frama-c.byte bin/frama-c-gui bin/frama-c-gui.byte \
      bin/frama-c-config share/frama-c.WIN32.rc share/frama-c.Unix.rc   \
      $(ICONS) $(FEEDBACK_ICONS_DEFAULT) $(FEEDBACK_ICONS_COLORBLIND)	\
      man/frama-c.1 doc/README						\
      doc/code/docgen.ml                                                \
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt					\
      doc/code/toc_head.htm                                             \
      doc/code/toc_tail.htm                                             \
      doc/Makefile                                                      \
      $(filter-out ptests/ptests_config.ml,$(wildcard ptests/*.ml*))   \
      configure.in Makefile Makefile.generating				\
      Changelog config.h.in						\
      VERSION $(wildcard licenses/*)                                    \
      $(LIBC_FILES)							\
      share/analysis-scripts/cmd-dep.sh                                 \
      share/analysis-scripts/frama-c.mk                                 \
      share/analysis-scripts/parse-coverage.sh                          \
      share/analysis-scripts/README.md                                  \
      $(wildcard share/emacs/*.el) share/autocomplete_frama-c           \
      share/_frama-c                                                    \
      share/configure.ac                                                \
      share/Makefile.config.in share/Makefile.common                    \
      share/Makefile.generic						\
      share/Makefile.plugin.template share/Makefile.dynamic		\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal				\
      $(filter-out src/kernel_internals/runtime/config.ml,              \
	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
      $(wildcard src/kernel_services/abstract_interp/*.ml*)             \
      $(wildcard src/plugins/gui/*.ml*)                                 \
      $(wildcard src/libraries/stdlib/*.ml*)                            \
      $(wildcard src/libraries/utils/*.ml*)                             \
      $(wildcard src/libraries/utils/*.c)                               \
      $(wildcard src/libraries/project/*.ml*)                           \
      $(filter-out src/kernel_internals/parsing/check_logic_parser.ml,  \
          $(wildcard src/kernel_internals/parsing/*.ml*))               \
      $(wildcard src/kernel_internals/typing/*.ml*)                     \
      $(wildcard src/kernel_services/ast_data/*.ml*)                    \
      $(wildcard src/kernel_services/ast_queries/*.ml*)                 \
      $(wildcard src/kernel_services/ast_printing/*.ml*)                \
      $(wildcard src/kernel_services/cmdline_parameters/*.ml*)          \
      $(wildcard src/kernel_services/analysis/*.ml*)                    \
      $(wildcard src/kernel_services/ast_transformations/*.ml*)         \
      $(wildcard src/kernel_services/plugin_entry_points/*.ml*)         \
      $(wildcard src/kernel_services/visitors/*.ml*)                    \
      $(wildcard src/kernel_services/parsetree/*.ml*)                   \
      $(wildcard src/libraries/datatype/*.ml*)                          \
      bin/sed_get_make_major bin/sed_get_make_minor                     \
      INSTALL.md README.md .make-clean	                        \
      .make-clean-stamp .force-reconfigure 	\
      opam/opam opam/descr \
      opam/files/run_autoconf_if_needed.sh

DISTRIB_TESTS=$(filter-out tests/non-free/%,$(shell git ls-files tests src/plugins/aorai/tests src/plugins/report/tests src/plugins/wp/tests))


# files that are needed to compile API documentation of external plugins
DOC_GEN_FILES:=$(addprefix doc/code/,\
	*.css intro_plugin.txt intro_kernel_plugin.txt \
	intro_plugin_default.txt intro_plugin_D_and_S \
	kernel-doc.ocamldoc \
	docgen.ml docgen.cm* *.htm)

################
# Main targets #
################

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests bin/fc-config$(EXE)

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(OCAMLBEST) $(EXTRAS) plugins_ptests_config

.PHONY: top opt byte dist bdist rebuild rebuild-branch

dist: clean
	$(QUIET_MAKE) all

clean-rebuild: clean
	$(QUIET_MAKE) all

rebuild: config.status
	$(MAKE) smartclean
	$(MAKE) depend $(FRAMAC_PARALLEL)
	$(MAKE) all $(FRAMAC_PARALLEL) || \
		(touch .force-reconfigure; \
		 $(MAKE) config.status && \
		 $(MAKE) depend $(FRAMAC_PARALLEL) && \
		 $(MAKE) all $(FRAMAC_PARALLEL))

sinclude .Makefile.user # Should defines FRAMAC_PARALLEL and FRAMAC_USER_FLAGS

=== doc/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file just download the manuals in the released version

all:download


FRAMAC_SRC=..
MAKECONFIG_DIR=$(FRAMAC_SRC)/share

include $(FRAMAC_SRC)/share/Makefile.common

DOCDIR ?= "$(DESTDIR)${prefix}/share/doc"
FRAMAC_DOCDIR ?= $(DOCDIR)/frama-c

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' $(FRAMAC_SRC)/VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###

.PHONY: force


MANUALS=acsl

#MANUALS that depend on the frama-c version
VERSIONED_MANUALS=acsl-implementation aorai-manual rte-manual	\
		  wp-manual metrics-manual user-manual		\
		  plugin-development-guide value-analysis

FILES= $(addprefix manuals/, \
	 $(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS)) \
         $(addsuffix .pdf, $(MANUALS)) \
	)


ifeq ($(DEVELOPMENT),yes)

download: force
	@echo "You can't download the manuals in this way for the development version"

else

download: force
	$(MKDIR) manuals
	wget -nv -N -P manuals \
	  $(addprefix http://frama-c.com/download/,$(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS))) \
	  $(addprefix http://frama-c.com/download/,$(addsuffix .pdf, $(MANUALS)))

endif

install:
	$(MKDIR) $(FRAMAC_DOCDIR)
	$(CP) $(FILES) $(FRAMAC_DOCDIR)

=== src/plugins/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml
PLUGIN_DISTRIB_EXTERNAL:=Makefile

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml
	$(RM) -r _build

=== src/plugins/studia/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

#######################
# Frama-C Environment #
#######################

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:= $(shell frama-c-config -print-share-path)
endif

ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:= $(shell frama-c-config -print-libpath)
endif

#########################
# Plug-in configuration #
#########################

PLUGIN_DIR ?=.
PLUGIN_NAME:=Studia
PLUGIN_CMO:=options writes reads
PLUGIN_GUI_CMO:=studia_gui
PLUGIN_DEPENDENCIES:=Value
PLUGIN_DISTRIB_EXTERNAL:= Makefile

################
# Generic part #
################

include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/plugins/wp/share/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################


# --------------------------------------------------------------------------
# ---  Coq Compilation
# --------------------------------------------------------------------------

.PHONY: all why3compile coqwpcompile clean depend wp-coq-clean

WPLSHARE=$(Wp_DIR)/share

wp-coq-clean:
	find $(Wp_DIR) \( -name "*.vo" -or -name "*.glob" \) -print -delete
	rm -f $(WPLSHARE)/coqwp/.depend $(WPLSHARE)/why3/.depend

clean:: wp-coq-clean

#########################
## For why3 directory ##

ifeq ($(WP_WHY3COQC_ENABLED),yes)

byte:: why3compile
opt:: why3compile

why3compile: $(addprefix $(WPLSHARE)/why3/, $(addsuffix o, $(COQ_LIBS_CEA)))

WHY3LIB:=$(shell why3 --print-libdir)
WHY3INCLUDES= -R $(WHY3LIB)/coq Why3 -R $(WPLSHARE)/why3 ''

$(WPLSHARE)/why3/%.vo: $(WPLSHARE)/why3/%.v
	echo "Coqc         $@"
	@coqc -w none $(WHY3INCLUDES) $<

$(WPLSHARE)/why3/.depend: $(addprefix $(WPLSHARE)/, $(WHY3_COQ_SOURCES))
	echo "Coqdep for $(WPLSHARE)/why3"
	@coqdep $(WHY3INCLUDES) -slash $(WPLSHARE)/why3/*.v $(WPLSHARE)/why3/**/*.v > $@

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),smartclean)
sinclude $(WPLSHARE)/why3/.depend
endif
endif
endif

endif # ($(WP_WHY3COQC_ENABLED),yes)

#########################
## For coqwp directory ##

ifeq ($(WP_COQC_ENABLED),yes)

byte:: coqwpcompile
opt:: coqwpcompile


coqwpcompile: $(addprefix $(WPLSHARE)/coqwp/, $(addsuffix o, $(COQ_LIBS_CEA) $(COQ_LIBS_INRIA)))

COQWPINCLUDES= -R $(WPLSHARE)/coqwp ''

$(WPLSHARE)/coqwp/%.vo: $(WPLSHARE)/coqwp/%.v
	echo "Coqc         $<"
	@coqc -w none $(COQWPINCLUDES) $<

$(WPLSHARE)/coqwp/.depend: $(addprefix $(WPLSHARE)/, $(WP_COQ_SOURCES))
	echo "Coqdep for $(WPLSHARE)/coqwp"
	@coqdep $(COQWPINCLUDES) -slash $(WPLSHARE)/coqwp/*.v $(WPLSHARE)/coqwp/**/*.v > $@

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),smartclean)
sinclude $(WPLSHARE)/coqwp/.depend
endif
endif
endif

endif #($(WP_COQC_ENABLED),yes)

# End of file

##########################################################################
# Local Variables:
# mode: makefile
# End:

=== src/plugins/wp/qed/src/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2017                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# ---  QED : a prover / simplifier in classical logic modulo             ---
# --------------------------------------------------------------------------

PACK?=no

include Makefile.src

LIB_ML:=$(QED_LIB_ML)
SRC_ML:=$(QED_SRC_ML)
SRC_MLI:=$(QED_SRC_MLI)

LBO= $(addsuffix .cmo,$(LIB_ML))
LBX= $(addsuffix .cmx,$(LIB_ML))
CML= $(addsuffix .cmi,$(SRC_MLI))
CMO= $(addsuffix .cmo,$(SRC_ML))
CMX= $(addsuffix .cmx,$(SRC_ML))
CMI= $(addsuffix .cmi,$(LIB_ML) $(SRC_MLI) $(SRC_ML))
DOC= $(addsuffix .mli,$(LIB_ML) $(SRC_MLI) $(SRC_ML))

.PHONY: all byte opt doc dot

all:  byte opt
byte: ../bin/Qed.cmo Makefile Makefile.src
opt:  ../bin/Qed.cmx Makefile Makefile.src
doc:  ../html/index.html
dot:  depend.pdf

Qed.cmo: $(LBO) $(CMO) $(CML)
	$(OCAMLC) -pack -o $@ $(LBO) $(CML) $(CMO)

# force byte compilation
ifeq ($(PACK),no)
Qed.cmx: Qed.cmo $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -o $@ $(LBX) $(CML) $(CMX)
else
Qed.cmx: Qed.cmo $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -for-pack $(PACK) -o $@ $(LBX) $(CML) $(CMX)
endif

../bin/Qed.cmo: Qed.cmo
	@mkdir -p ../bin
	cp Qed.cmo Qed.cmi ../bin/

# force byte installation
../bin/Qed.cmx: Qed.cmx ../bin/Qed.cmo
	cp Qed.cmx Qed.o ../bin/

../html/index.html: $(DOC) Makefile feedback.ml
	@rm -fr ../html
	@mkdir -p ../html
	$(OCAMLDOC) -html -d ../html -t "Qed Library" -stars $(DOC) | ocaml unix.cma feedback.ml
	@cp -f ocamldoc.css ../html/style.css

depend.pdf: depend.dot
	dot -T pdf -Grotate=180 -o $@ $<

depend.dot: .depend $(CMI)
	$(OCAMLDOC) -dot-reduce -o $@ -dot $(addsuffix .mli,$(SRC_MLI)) $(addsuffix .ml,$(LIB_ML) $(SRC_ML))

clean::
	rm -fr ../html
	rm -f depend.dot depend.pdf

distclean::
	rm -f ../bin/Qed.*

OPTML= -bin-annot -w PSUZ+7-3 -warn-error PSUZ+7-3
INCLUDES:=$(shell ocamlfind query zarith -i-format)
OPTCMI=
OPTCMO=
ifeq ($(PACK),no)
OPTCMX= -for-pack Qed
else
OPTCMX= -for-pack $(PACK).Qed
endif

include MakeOcaml

=== debian/changelog ===
frama-c (20171101+sulfur+dfsg-2) unstable; urgency=medium

  * Team upload
  * Stop building the GUI, drop frama-c binary package (Closes: #911159)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 12 Nov 2018 11:44:42 +0100

frama-c (20171101+sulfur+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches and remove the following ones which were applied
    upstream:
    - 0001-Fix-spelling-error-in-binary.patch
    - 0006-gui.byte-needs-TARGETS_GUI_BYTE-only.patch
    - 0008-More-fixes-of-spelling-errors.patch
    - 0009-Better-handling-of-dynlink-detection.patch
    - 0010-Add-zsh-completion-file.patch
    - 0011-Fix-installation-target-on-bytecode-architectures.patch
    - 0012-Do-not-use-C-CPPFLAG-when-compiling-jemalloc.patch
  * Update Vcs-* fields in order to use Salsa repositories
  * Fix installation on bytecode architectures
    - add 0006-Fix-installation-on-bytecode-architectures.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 11 May 2018 17:39:36 +0200

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.12.0~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libocamlgraph-ocaml-dev (>> 1.8.5~),
Standards-Version: 3.9.8
Homepage: http://frama-c.com/
Vcs-Browser: https://salsa.debian.org/ocaml-team/frama-c
Vcs-Git: https://salsa.debian.org/ocaml-team/frama-c.git

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
Recommends:
 alt-ergo
Description: Platform dedicated to the analysis of source code written in C (without gui)
 Frama-C gathers several analysis techniques in a single collaborative
 framework, based on analyzers (called "plug-ins") that can build upon the
 results computed by other analyzers in the framework.
 .
 Thanks to this approach, Frama-C provides sophisticated tools, including:
   * an analyzer based on abstract interpretation (Value plug-in);
   * a program proof framework based on weakest precondition calculus (WP plug-in);
   * a program slicer (Slicing plug-in);
   * a tool for verification of temporal (LTL) properties (Aoraï plug-in);
   * several tools for code base exploration and dependency analysis
     (plug-ins From, Impact, Metrics, Occurrence, Scope, etc.).
 .
 These plug-ins communicate between each other via the Frama-C API
 and via ACSL (ANSI/ISO C Specification Language) properties.
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

## frama-c 20191204%2Bcalcium

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2017                                               #
+#  Copyright (C) 2007-2019                                               #
 #    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
@@ -24,21 +24,22 @@
 
 FRAMAC_SRC=.
 MAKECONFIG_DIR=share
-
+PLUGIN_TESTS_LIST:=
 include share/Makefile.common
 include share/Makefile.dynamic_config.internal
 
 #Check share/Makefile.config available
 ifndef FRAMAC_ROOT_SRCDIR
-$(error "You should run ./configure first (or autoconf if there is no configure)")
+$(error \
+  "You should run ./configure first (or autoconf if there is no configure)")
 endif
 
 ###################
 # Frama-C Version #
 ###################
 
-VERSION:=$(shell $(SED) -e 's/\(\.*\)/\1/' VERSION)
-VERSION_PREFIX = $(shell $(SED) -e 's/\([a-zA-Z]\+-[0-9]\+\).*/\1/' VERSION)
+VERSION:=$(shell $(CAT) VERSION)
+VERSION_CODENAME:=$(shell $(CAT) VERSION_CODENAME)
 
 ###########################
 # Global plugin variables #
@@ -82,16 +83,33 @@
 PLUGIN_DIST_DOC_LIST:=
 PLUGIN_BIN_DOC_LIST:=
 PLUGIN_DIST_EXTERNAL_LIST:=
-PLUGIN_TESTS_LIST:=
+PLUGIN_DIST_TESTS_LIST:=
 PLUGIN_DISTRIBUTED_NAME_LIST:=
+MERLIN_PACKAGES:=
+
+PLUGIN_HEADER_SPEC_LIST :=
+PLUGIN_HEADER_DIRS_LIST :=
+PLUGIN_HEADER_EXCEPTIONS_LIST :=
+PLUGIN_CEA_PROPRIETARY_HEADERS_LIST :=
+PLUGIN_CEA_PROPRIETARY_FILES_LIST :=
+
+# default value used for HEADER_SPEC and PLUGIN_HEADER_SPEC
+DEFAULT_HEADER_SPEC := headers/header_spec.txt
+# default value used for HEADER_DIRS and PLUGIN_HEADER_DIRS
+DEFAULT_HEADER_DIRS := headers
+# default value used for HEADER_EXCEPTIONS and PLUGIN_HEADER_EXCEPTIONS
+DEFAULT_HEADER_EXCEPTIONS := configure
+# default value used for CEA_PROPRIETARY_FILES and PLUGIN_CEA_PROPRIETARY_FILES
+DEFAULT_CEA_PROPRIETARY_FILES := tests/non-free/%
+# default value used for CEA_PROPRIETARY_HEADERS
+# and PLUGIN_CEA_PROPRIETARY_HEADERS
+DEFAULT_CEA_PROPRIETARY_HEADERS := CEA_PROPRIETARY
+
+MERLIN_PACKAGES:=
 
 ###############################
 # Additional global variables #
 ###############################
-
-# put here any config option for the binary distribution outside of
-# plugins
-CONFIG_DISTRIB_BIN:=
 
 # Directories containing some source code
 SRC_DIRS= ptests $(PLUGIN_LIB_DIR) $(FRAMAC_SRC_DIRS)
@@ -110,23 +128,27 @@
 GUI_INCLUDES =
 endif
 
-# Files for which dependencies must be computed computed.
+# Files for which dependencies must be computed.
 # Other files are added later in this Makefile.
 FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli
 
 BFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) \
-		$(FRAMAC_USER_FLAGS)
+		$(FRAMAC_USER_BFLAGS)
 OFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) -compact \
-		$(FRAMAC_USER_FLAGS)
+		$(FRAMAC_USER_OFLAGS)
 
 BLINKFLAGS += -linkpkg $(BFLAGS) -linkall -custom
 OLINKFLAGS += -linkpkg $(OFLAGS) -linkall
 
-DOC_FLAGS= -colorize-code -stars -m A -hide-warnings $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)
+DOC_FLAGS= -charset utf8 -colorize-code -stars -m A $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)
+
+ifneq ($(VERBOSEMAKE),yes)
+DOC_FLAGS+= -hide-warnings
+endif
 
 # Files that depend on external libraries -namely Zarith- whose interface
 # has not been explicitely declared -opaque, hence would trigger warning 58.
-# This can't be solve by Frama-C itself, we can only wait for an update of
+# This can't be solved by Frama-C itself, we can only wait for an update of
 # said library.
 
 NON_OPAQUE_DEPS:=
@@ -145,9 +167,9 @@
 
 ICONS:= $(addprefix share/,\
 		frama-c.ico frama-c.png unmark.png \
-		switch-on.png switch-off.png )
-
-FEEDBACK_ICONS_NAMES:= \
+		switch-on.png switch-off.png)
+
+THEME_ICON_NAMES:= \
 		never_tried.png \
 		unknown.png \
 		surely_valid.png \
@@ -158,15 +180,18 @@
 		invalid_but_dead.png \
 		unknown_but_dead.png \
 		valid_but_dead.png \
-		inconsistent.png
-
-FEEDBACK_ICONS_DEFAULT:= \
-	$(addprefix share/theme/default/,$(FEEDBACK_ICONS_NAMES))
-FEEDBACK_ICONS_COLORBLIND:= \
-	$(addprefix share/theme/colorblind/,$(FEEDBACK_ICONS_NAMES))
+		inconsistent.png \
+		fold.png unfold.png
+
+THEME_ICONS_DEFAULT:= \
+  $(addprefix share/theme/default/,$(THEME_ICON_NAMES))
+THEME_ICONS_COLORBLIND:= \
+  $(addprefix share/theme/colorblind/,$(THEME_ICON_NAMES))
+THEME_ICONS_FLAT:= \
+  $(addprefix share/theme/flat/,$(THEME_ICON_NAMES))
 
 ROOT_LIBC_DIR:= share/libc
-LIBC_SUBDIRS:= sys netinet linux net arpa
+LIBC_SUBDIRS:= sys netinet net arpa
 LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/,$(LIBC_SUBDIRS))
 LIBC_FILES:= \
 	$(wildcard share/*.h share/*.c) \
@@ -209,10 +234,12 @@
 # itself, rather than copied: otherwise, it could include references to
 # non-distributed plug-ins.
 DISTRIB_FILES:=\
-      $(wildcard bin/migration_scripts/*2*.sh) bin/local_export.sh                        \
+      $(wildcard bin/migration_scripts/*2*.sh) bin/local_export.sh      \
       bin/frama-c bin/frama-c.byte bin/frama-c-gui bin/frama-c-gui.byte \
-      bin/frama-c-config share/frama-c.WIN32.rc share/frama-c.Unix.rc   \
-      $(ICONS) $(FEEDBACK_ICONS_DEFAULT) $(FEEDBACK_ICONS_COLORBLIND)	\
+      bin/frama-c-config bin/frama-c-script                             \
+      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
+      $(ICONS) $(THEME_ICONS_DEFAULT) $(THEME_ICONS_COLORBLIND)         \
+      $(THEME_ICONS_FLAT)                                               \
       man/frama-c.1 doc/README						\
       doc/code/docgen.ml                                                \
       doc/code/*.css doc/code/intro_plugin.txt				\
@@ -225,20 +252,40 @@
       $(filter-out ptests/ptests_config.ml,$(wildcard ptests/*.ml*))   \
       configure.in Makefile Makefile.generating				\
       Changelog config.h.in						\
-      VERSION $(wildcard licenses/*)                                    \
+      VERSION VERSION_CODENAME $(wildcard licenses/*)                   \
       $(LIBC_FILES)							\
+      share/analysis-scripts/benchmark_database.py                      \
       share/analysis-scripts/cmd-dep.sh                                 \
+      share/analysis-scripts/concat-csv.sh                              \
+      share/analysis-scripts/clone.sh                                   \
+      $(wildcard share/analysis-scripts/examples/*)                     \
+      share/analysis-scripts/fc_stubs.c                                 \
+      share/analysis-scripts/find_fun.py                                \
+      share/analysis-scripts/flamegraph.pl                              \
       share/analysis-scripts/frama-c.mk                                 \
+      share/analysis-scripts/frama_c_results.py                         \
+      share/analysis-scripts/git_utils.py                               \
+      share/analysis-scripts/list_files.py                              \
+      share/analysis-scripts/make_template.py                           \
+      share/analysis-scripts/make_wrapper.py                            \
       share/analysis-scripts/parse-coverage.sh                          \
       share/analysis-scripts/README.md                                  \
+      share/analysis-scripts/results_display.py                         \
+      share/analysis-scripts/summary.py                                 \
+      share/analysis-scripts/template.mk                                \
       $(wildcard share/emacs/*.el) share/autocomplete_frama-c           \
       share/_frama-c                                                    \
+      share/compliance/c11_functions.json                               \
+      share/compliance/glibc_functions.json                             \
+      share/compliance/nonstandard_identifiers.json                     \
+      share/compliance/posix_identifiers.json                           \
       share/configure.ac                                                \
       share/Makefile.config.in share/Makefile.common                    \
       share/Makefile.generic						\
       share/Makefile.plugin.template share/Makefile.dynamic		\
       share/Makefile.dynamic_config.external				\
       share/Makefile.dynamic_config.internal				\
+      share/META.frama-c                                                \
       $(filter-out src/kernel_internals/runtime/config.ml,              \
 	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
       $(wildcard src/kernel_services/abstract_interp/*.ml*)             \
@@ -247,67 +294,3 @@
       $(wildcard src/libraries/utils/*.ml*)                             \
       $(wildcard src/libraries/utils/*.c)                               \
       $(wildcard src/libraries/project/*.ml*)                           \
-      $(filter-out src/kernel_internals/parsing/check_logic_parser.ml,  \
-          $(wildcard src/kernel_internals/parsing/*.ml*))               \
-      $(wildcard src/kernel_internals/typing/*.ml*)                     \
-      $(wildcard src/kernel_services/ast_data/*.ml*)                    \
-      $(wildcard src/kernel_services/ast_queries/*.ml*)                 \
-      $(wildcard src/kernel_services/ast_printing/*.ml*)                \
-      $(wildcard src/kernel_services/cmdline_parameters/*.ml*)          \
-      $(wildcard src/kernel_services/analysis/*.ml*)                    \
-      $(wildcard src/kernel_services/ast_transformations/*.ml*)         \
-      $(wildcard src/kernel_services/plugin_entry_points/*.ml*)         \
-      $(wildcard src/kernel_services/visitors/*.ml*)                    \
-      $(wildcard src/kernel_services/parsetree/*.ml*)                   \
-      $(wildcard src/libraries/datatype/*.ml*)                          \
-      bin/sed_get_make_major bin/sed_get_make_minor                     \
-      INSTALL.md README.md .make-clean	                        \
-      .make-clean-stamp .force-reconfigure 	\
-      opam/opam opam/descr \
-      opam/files/run_autoconf_if_needed.sh
-
-DISTRIB_TESTS=$(filter-out tests/non-free/%,$(shell git ls-files tests src/plugins/aorai/tests src/plugins/report/tests src/plugins/wp/tests))
-
-
-# files that are needed to compile API documentation of external plugins
-DOC_GEN_FILES:=$(addprefix doc/code/,\
-	*.css intro_plugin.txt intro_kernel_plugin.txt \
-	intro_plugin_default.txt intro_plugin_D_and_S \
-	kernel-doc.ocamldoc \
-	docgen.ml docgen.cm* *.htm)
-
-################
-# Main targets #
-################
-
-# additional compilation targets for 'make all'.
-# cannot be delayed after 'make all'
-EXTRAS	= ptests bin/fc-config$(EXE)
-
-ifneq ($(ENABLE_GUI),no)
-ifeq ($(HAS_LABLGTK),yes)
-EXTRAS	+= gui
-endif
-endif
-
-all:: byte $(OCAMLBEST) $(EXTRAS) plugins_ptests_config
-
-.PHONY: top opt byte dist bdist rebuild rebuild-branch
-
-dist: clean
-	$(QUIET_MAKE) all
-
-clean-rebuild: clean
-	$(QUIET_MAKE) all
-
-rebuild: config.status
-	$(MAKE) smartclean
-	$(MAKE) depend $(FRAMAC_PARALLEL)
-	$(MAKE) all $(FRAMAC_PARALLEL) || \
-		(touch .force-reconfigure; \
-		 $(MAKE) config.status && \
-		 $(MAKE) depend $(FRAMAC_PARALLEL) && \
-		 $(MAKE) all $(FRAMAC_PARALLEL))
-
-sinclude .Makefile.user # Should defines FRAMAC_PARALLEL and FRAMAC_USER_FLAGS
-

=== src/plugins/print_api/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2017                                               #
+#  Copyright (C) 2007-2019                                               #
 #    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,8 @@
  libzarith-ocaml-dev,
  ocaml-findlib,
  libfindlib-ocaml-dev,
+ libyojson-ocaml-dev,
+ libwhy3-ocaml-dev,
  libocamlgraph-ocaml-dev (>> 1.8.5~),
 Standards-Version: 3.9.8
 Homepage: http://frama-c.com/
